// Created By:
// Apple-Group Development Team
// http://www.apple-group.com
// March 2008

function hideMainControls()
{
	document.getElementById('logo').style.display = 'none';
	document.getElementById('newFeedButton').style.display = 'none';
	document.getElementById('done').style.display = 'none';
	//document.getElementById('popup').style.display = 'none';
	document.getElementById('articlesCheckBox').style.display = 'none';
	document.getElementById('rowsCheckBox').style.display = 'none';
	//document.getElementById('styleLabel').style.display = 'none';
	document.getElementById('articlesLabel').style.display = 'none';
	document.getElementById('rowsLabel').style.display = 'none';
}

function showMainControls()
{
	document.getElementById('logo').style.display = '';
	document.getElementById('newFeedButton').style.display = '';
	document.getElementById('done').style.display = '';
	//document.getElementById('popup').style.display = '';
	document.getElementById('articlesCheckBox').style.display = '';
	document.getElementById('rowsCheckBox').style.display = '';
	//document.getElementById('styleLabel').style.display = '';
	document.getElementById('articlesLabel').style.display = '';
	document.getElementById('rowsLabel').style.display = '';
}

function hideUrlControls()
{
	document.getElementById(formerFStyleID).style.display = 'none';
	document.getElementById('plus').style.display = 'none';
	document.getElementById('minus').style.display = 'none';
	document.getElementById('feedInputText').style.display = 'none';
	document.getElementById('okayButton').style.display = 'none';
	document.getElementById('cancelButton').style.display = 'none';
}

function showUrlControls()
{
	document.getElementById(formerFStyleID).style.display = '';
	document.getElementById('plus').style.display = '';
	document.getElementById('minus').style.display = '';
	document.getElementById('feedInputText').style.display = '';
	document.getElementById('okayButton').style.display = '';
	document.getElementById('cancelButton').style.display = '';
}

function newFeed(event)
{
	formerFeed = feed.url;
    showUrlControls();
	hideMainControls();
	loadFavorites();
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function okayClick(event)
{
    hideUrlControls();
	showMainControls();
	saveFavoritePreferences();
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function cancelClick(event)
{
	setFeedSource(formerFeed);
    hideUrlControls();
	showMainControls();
}

function articlesChanged()
{
	var showArticles = document.getElementById('articlesCheckBox').checked;
	if (window.widget) isArticle = !(showArticles);
	
	refreshFeed();
}

function rowsChanged()
{
	var altRows = document.getElementById('rowsCheckBox').checked;
	if (window.widget) isAlt = altRows
	
	refreshFeed();
}

function rowsLabelClick(event)
{
	var element = document.getElementById('rowsCheckBox');
	
	element.checked = !element.checked;
	rowsChanged();
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function articlesLabelClick(event)
{
	var element = document.getElementById('articlesCheckBox');
	
	element.checked = !element.checked;
	articlesChanged();
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function styleChanged(element)
{
	style = element.options[element.selectedIndex].value;
	updateStyle();
}

function updateStyle()
{
	document.getElementById("frontImg").src = "Images/" + style + "/front.png";
	document.getElementById("logo").src = "Images/" + style + "/logo.png";
	
	if (!Open) {
		var newLStyleID = ("leftBar-" + style);
		document.getElementById(formerLStyleID).setAttribute("id", newLStyleID);
		formerLStyleID = newLStyleID;
	}
	else {
		var newLStyleID = ("leftBar-Open-" + style);
		document.getElementById(formerLStyleID).setAttribute("id", newLStyleID);
		formerLStyleID = newLStyleID;
	}
	
	var newTStyleID = ("theTitle-" + style);
	document.getElementById(formerTStyleID).setAttribute("id", newTStyleID);
	formerTStyleID = newTStyleID;
	
	setupScrollAreas();
}

function setupScrollAreas()
{
	var temp = new Array();
	temp = formerMStyleID.split('-');
	if (temp[1] == "Open") {
		var newMStyleID = ("rssContentArea-Open-" + style);
	}
	else {
		var newMStyleID = ("rssContentArea-" + style);
	}
	var newFStyleID = ("fContentArea-" + style);
	var newFsStyleID = ("feedContentArea-" + style);
	var newLltStyleID = ("lastLoadText-" + style);

	document.getElementById(formerMStyleID).setAttribute("id", newMStyleID);
	formerMStyleID = newMStyleID;
	document.getElementById(formerFStyleID).setAttribute("id", newFStyleID);
	formerFStyleID = newFStyleID;
	document.getElementById(formerFsStyleID).setAttribute("id", newFsStyleID);
	formerFsStyleID = newFsStyleID;
	document.getElementById(formerLltStyleID).setAttribute("id", newLltStyleID);
	formerLltStyleID = newLltStyleID;
	
	temp = null;
}

function loadFavorites()
{
	clearFContentArea();
	
	favoriteFeeds = new Array;
	var c = loadFavoritePreferences('0');
	if (c != null) {
		for (var i = 1; i <= c; i++)
		{
			favoriteFeeds[favoriteFeeds.length] = loadFavoritePreferences('' + i);
		}
	}
	else {
		favoriteFeeds[favoriteFeeds.length] = NS_DF;
		favoriteFeeds[favoriteFeeds.length] = NS_DFT;
		favoriteFeeds[favoriteFeeds.length] = NS_DFTT;
		favoriteFeeds[favoriteFeeds.length] = NS_DFFT;
		favoriteFeeds[favoriteFeeds.length] = NS_DFFFT;
        favoriteFeeds[favoriteFeeds.length] = NS_1;
        favoriteFeeds[favoriteFeeds.length] = NS_2;
        favoriteFeeds[favoriteFeeds.length] = NS_3;
        favoriteFeeds[favoriteFeeds.length] = NS_4;
        favoriteFeeds[favoriteFeeds.length] = NS_5;
        favoriteFeeds[favoriteFeeds.length] = NS_6;
        favoriteFeeds[favoriteFeeds.length] = NS_7;
	}
	
	if (favoriteFeeds.length > 0) {
		populateFavorites();
	}
	refreshFContentArea();
}

function reloadFavorites()
{
	clearFContentArea();
	if (favoriteFeeds.length > 0)
	{
		populateFavorites();
	}
	refreshFContentArea();
}

function populateFavorites()
{
    var c = favoriteFeeds.length;

    var contentElement = document.getElementById("fContent");
    for (var i = 0; i < c; ++i) {
        var item = favoriteFeeds[i];
        var row = createFavoriteRow(item, i);
        contentElement.appendChild(row);
    }
	refreshfContentArea();
}

function createFavoriteRow(item, index)
{	
	if (item != null) {
		var favorite = document.createElement("div");
		var favRow = makeEntryDiv(item);
		
		favRow.setAttribute("class", "row");
		favRow.setAttribute("onclick", "selectFavorite(event, " + index + ");");
        //favRow.setAttribute("onkeypress", "rowKeyPress(event, " + index + ");");
		favRow.setAttribute("id", "favorite" + index);
		favorite.appendChild(favRow);
	}

    return favorite;
}

function selectFavorite(event, index)
{
	var row = document.getElementById("favorite" + index);
	if (index >= 0) {
		if (selectedRow) {
			selectedRow.setAttribute("class","row");
		}
		if (row) {
			row.setAttribute("class", "row selected");
			selectedRow = row;
			selectedIndex = index;
		}
	}
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function favoriteSelected(event, index)
{
	var theFeed = favoriteFeeds[index]
	setFeedSource(theFeed);
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function clearFContentArea()
{
	 var content = document.getElementById("fContent");

    if (content) {
        while (content.hasChildNodes()) {
            content.removeChild(content.firstChild);
        }
    }
}

function refreshFContentArea()
{
    var contentarea = document.getElementById("fContentArea");
    if (contentarea) contentarea.object.refresh();
}

function addFavorite(event)
{
	var f = document.getElementById('feedInputText').value;
	
    if (f != '')
	{
        x = compareToFeeds(f);
        if (x > 0) {
            selectFavorite(null, x);
        }
        else {
            favoriteFeeds[favoriteFeeds.length] = f;
            reloadFavorites();
        }
	}
	document.getElementById('feedInputText').value = '';
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function deleteFavorite(event)
{
	var results = new Array;
	var c = 0;
	
	for (var i = 0; i < favoriteFeeds.length; i++)
	{
		if (i != selectedIndex)
		{
			results[c] = favoriteFeeds[i];
			c++;
		}
	}
	
	if (feed.url == favoriteFeeds[selectedIndex]) {
		favoriteFeeds = results;
		reloadFavorites();
		nextSelectedFavorite(true);
	}
	else {
		favoriteFeeds = results;
		reloadFavorites();
		nextSelectedFavorite(false);
	}
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function launchAG(event)
{
	if (window.widget) widget.openURL('http://www.apple-group.com');
	
	if(event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

//flag = is the favorite being deleted also the favorite that is loaded as the feed.
//First sub branch handles situations where the selected favorite is first or in the middle of the list.
//Second sub branch handles situations where the selcted favorite is last in the list.
function nextSelectedFavorite(flag)
{
	if (flag) {
		if (selectedIndex < favoriteFeeds.length) {
			favoriteSelected(null, selectedIndex);
			selectFavorite(null, selectedIndex);
		}
		else if (selectedIndex >= favoriteFeeds.length) {
			favoriteSelected(null, (selectedIndex - 1));
			selectFavorite(null, (selectedIndex - 1));
		}
	}
	else {
		if (selectedIndex < favoriteFeeds.length) {
			selectFavorite(null, selectedIndex);
		}
		else if (selectedIndex >= favoriteFeeds.length) {
			selectFavorite(null, (selectedIndex - 1));
		}
	}
}

function refreshfContentArea()
{
    var contentarea = document.getElementById(formerFStyleID);
    if (contentarea) contentarea.object.refresh();
}

function compareToFeeds(newFeed)
{
    //for (var i=0; i < favoriteFeeds.length; i++)
    var i = 0;
    while (i < favoriteFeeds.length)
    {
        if (newFeed == favoriteFeeds[i]) {
            return i;
        }
        i++;
    }
    return -1;
}

function symbolKeyPress(event)
{
    //alert (event.keyCode);
    var flag = 0;
    switch (event.keyCode)
	{
        case 13:    // return
		case 3:     // enter
            flag = 1;
            break;
	}
    
    if (flag > 0)
    {
        addFavorite(null);
    }
}